/*
 * BondVectorsUnitTest.hpp
 *
 *  Created on: Jun 29, 2017
 *      Author: heber
 */

#ifndef BONDVECTORSUNITTEST_HPP_
#define BONDVECTORSUNITTEST_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <cppunit/extensions/HelperMacros.h>

#include <vector>

#include "Bond/bond.hpp"

class atom;
class BondVectors;
class element;

/********************************************** Test classes **************************************/

class BondVectorsTest : public CppUnit::TestFixture
{
    CPPUNIT_TEST_SUITE( BondVectorsTest) ;
    CPPUNIT_TEST ( current_mappedTest );
    CPPUNIT_TEST ( weights_singlebondTest );
    CPPUNIT_TEST ( weights_linearchainTest );
    CPPUNIT_TEST ( weights_rightangleTest );
    CPPUNIT_TEST ( weights_triangleTest );
    CPPUNIT_TEST_SUITE_END();

public:
      void setUp();
      void tearDown();
      void current_mappedTest();
      void weights_singlebondTest();
      void weights_linearchainTest();
      void weights_rightangleTest();
      void weights_triangleTest();

private:
      enum atomPositions
      {
        left,
        center,
        right,
        top,
        topright,
        bottom,
        bottomright
      };

      BondVectors *bv;
      std::vector<atom *> atoms;
      std::vector<atom *> atomvector;
      std::vector<bond::ptr> bondvector;
      atom * _atom;
      bond * _bond;
      const element * carbon;
};

#endif /* BONDVECTORSUNITTEST_HPP_ */
